// Dr Benoit Chaperot 2025, inspired by AI Junkie, Mat Buckland 2002

using System;
using UnityEngine;

namespace OkayAI.GA
{
	public partial class GenAlg
	{
		[Serializable]
		public class Parameters
		{
			[HideInInspector]
			public int populationSize;

			[HideInInspector]
			// number of weights per chromosome
			public int chromoLength;

			// probability that a chromosomes bits will mutate.
			// Try figures around 0.05 to 0.3 ish
			public double mutationRate = 0.1;
			public double mutationPerturbation = 0.3;

			// probability of chromosomes crossing over bits
			// 0.7 is pretty good
			public double crossoverRate = 0.7;

			public int eliteNumBest = 4;
			public int eliteNumCopies = 1;

			public float generationTime = 30f;

			public string filename = "ga.sav";
			public bool loadFromFile = true;
			public bool saveToFile = true;
		}

		[HideInInspector]
		public Parameters parameters = new Parameters();
	}
}
