using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(Camera))]
public class GenerateSprites : MonoBehaviour
{
	[Serializable]
	public class Sprite
	{
		public GameObject gameObject;
		public RenderTexture renderTexture;
		public string filename;

		public IEnumerator Save(Camera camera)
		{
			gameObject.SetActive(true);
			camera.targetTexture = renderTexture;

			yield return null;
			yield return null;

			byte[] bytes = ToTexture2D(renderTexture).EncodeToPNG();
			System.IO.File.WriteAllBytes(filename, bytes);

			gameObject.SetActive(false);
		}

		static Texture2D ToTexture2D(RenderTexture inRenderTexture)
		{
			Texture2D texture = new Texture2D(inRenderTexture.width, inRenderTexture.height, TextureFormat.RGBA32, false);
			RenderTexture.active = inRenderTexture;
			texture.ReadPixels(new Rect(0, 0, inRenderTexture.width, inRenderTexture.height), 0, 0);
			texture.Apply();
			Destroy(texture);
			return texture;
		}
	}

	public Sprite[] sprites = new Sprite[2];

	IEnumerator Start()
	{
		Camera camera = gameObject.GetComponent<Camera>();

		foreach (Sprite sprite in sprites)
		{
			yield return sprite.Save(camera);
		}
	}
}
