// Dr Benoit Chaperot 2025, inspired by AI Junkie, Mat Buckland 2002

using System;
using System.Collections.Generic;

namespace OkayAI.GA
{
	[Serializable]
	public struct Genome : IComparable<Genome>
	{
		public List<double>		weights;
		public double	fitness;

		public Genome(double inFitness)
		{
			weights = new List<double>();
			fitness = inFitness;
		}

		public Genome(List<double> inWeights, double inFitness)
		{
			weights = inWeights;
			fitness = inFitness;
		}

		public List<double> GetWeights() => weights;
		public int CompareTo(Genome other)
		{
			return fitness.CompareTo(other.fitness);
		}
	};
}

